// Tile engine
// THIS ENGINE ONLY REQUIRES ALLEGRO
#include <allegro.h>
#include "grids.h"
#include "math.h"

// variables
int endgame;
int p1x;
int p1y;
int p1h;
int p2x;
int p2y;
int p2h;
int p1charge;
int p2charge;
bool p1won;
bool p2won;
bool tick;
char flashticker;
int level;
int pausetimer;
bool gameover;
bool waiting;

char history[57][47][32];
int p1healthhistory[57];
int p2healthhistory[57];
char blast[47][32];
char newblast[47][32];

int curtime;

char mode;  //0 title, 1 game;
bool p1dead;
bool p2dead;

// Bitmap pointers
BITMAP *buffer;


int max(int a, int b)
{
if (a<=b) return b;
else return a;
}

int min(int a, int b)
{
if (a>=b) return b;
else return a;
}

int d(int x1, int y1, int x2, int y2)
{
	return (int) (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
} 

/* FRAMERATE CONTROL*/


volatile unsigned int frames, fps;
void second_counter(void)
{
        fps=frames;
        frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
        ++ticks;
} END_OF_FUNCTION(ticker);


//---------------------------------------------------------
// INITIALIZATION FUNCTION
//---------------------------------------------------------

void reset_variables()
{

  register int i, j, k;

    for (i = 0; i < 47; i++)
    {
        for (j = 0; j < 32; j++)
        {
		   for (k = 0; k<57;k++)
			history[k][i][j]=0;
		blast[i][j]=0;
		newblast[i][j]=0;
        }
    }
	
	for (k=0;k<57;k++)
	{
		p1healthhistory[k]=100;
		p2healthhistory[k]=100;
	}
	
	p1charge=20;
	p2charge=20;

endgame=0;
p1x = 1;
p1y = 1;
p1h = 100;
p2x = 30;
p2y = 45;
p2h = 100;
tick=true;
flashticker = 0;
level = 1;
pausetimer=50;
gameover=false;
p1won=false;
p2won=false;
p1dead=false;
p2dead=false;
mode=0;
curtime=0;
waiting=true;
}


void init ()
{
// Install keyboard & timer
install_keyboard();
install_timer();

reset_variables();
}


//---------------------------------------------------------
// DRAW BUFFER
//---------------------------------------------------------

// showBuffer copies the contents of the buffer bitmap to the actual screen
void showBuffer ()
{
// Blit to screen
 blit (buffer, screen, 0, 0, 0, 0, 1024, 768);
}

//---------------------------------------------------------
// INPUT
//---------------------------------------------------------

void input ()
{

if (mode==2){

p1charge=min(p1charge+1,30);
p2charge=min(p2charge+1,30);

if(!(p1dead || p1won))
{
// If up is pressed, move player up
if (key[KEY_UP]&&!mapsolid[level][p1y-1][p1x]&&(p1y>0))
{
 p1y--;
}
// If down is pressed, move player down
else if (key[KEY_DOWN]&&!mapsolid[level][p1y+1][p1x]&&(p1y<46))
{
 p1y++;
}
 // If left is pressed, move player left
else if (key[KEY_LEFT]&&!mapsolid[level][p1y][p1x-1]&&(p1x>0))
{
 p1x--;
} // If up is pressed, move player right
else if (key[KEY_RIGHT]&&!mapsolid[level][p1y][p1x+1]&&(p1x<31))
{
 p1x++;
} 

if (key[KEY_SPACE]&&(p1charge>=10))
{
    p1charge-=10;
 if	(!mapsolid[level][p1y-1][p1x]&&(p1y>0)) 
	{
		blast[p1y-1][p1x]=1;
	}
 if	(!mapsolid[level][p1y+1][p1x]&&(p1y<46)) 
	{
		blast[p1y+1][p1x]=2;
	}
 if	(!mapsolid[level][p1y][p1x-1]&&(p1x>0)) 
	{
		blast[p1y][p1x-1]=3;
	}
 if	(!mapsolid[level][p1y][p1x+1]&&(p1x<31)) 
	{
		blast[p1y][p1x+1]=4;		
	}

}
}

if (!(p2dead || p2won))
{
// If up is pressed, move player up
if (key[KEY_W]&&!mapsolid[level][p2y-1][p2x]&&(p2y>0))
{
 p2y--;
}
// If down is pressed, move player down
else if (key[KEY_S]&&!mapsolid[level][p2y+1][p2x]&&(p2y<46))
{
 p2y++;
}
 // If left is pressed, move player left
else if (key[KEY_A]&&!mapsolid[level][p2y][p2x-1]&&(p2x>0))
{
 p2x--;
} // If up is pressed, move player right
else if (key[KEY_D]&&!mapsolid[level][p2y][p2x+1]&&(p2x<31))
{
 p2x++;
} 

if (key[KEY_F]&&(p2charge>=10))
{
	p2charge-=10;
 if	(!mapsolid[level][p2y-1][p2x]&&(p2y>0)) 
	{
		blast[p2y-1][p2x]=1;
	}
 if	(!mapsolid[level][p2y+1][p2x]&&(p2y<46)) 
	{
		blast[p2y+1][p2x]=2;
	}
 if	(!mapsolid[level][p2y][p2x-1]&&(p2x>0)) 
	{
		blast[p2y][p2x-1]=3;
	}
 if	(!mapsolid[level][p2y][p2x+1]&&(p2x<31)) 
	{
		blast[p2y][p2x+1]=4;		
	}

}
}

if (gameover)
	if (key[KEY_SPACE])
	{
		reset_variables();
	}
}
else if ((mode==1)&&(!waiting))
{
	if (key[KEY_SPACE])
	{
		mode=2;
		pausetimer=50;
		waiting=true;
		flashticker=0;
	}
	
	if (key[KEY_UP]||key[KEY_DOWN])
	{
		level=(level+3)%6;
		pausetimer=5;
		waiting=true;
		flashticker=0;

	}
			
	if (key[KEY_LEFT])
	{
		if (level==0)
			level=2;
		else if (level==3)
			level=5;
		else level=(level-1);
		pausetimer=5;
		waiting=true;
		flashticker=0;

	}
	
	
	if (key[KEY_RIGHT])
	{
		if (level==2)
			level=0;
		else if (level==5)
			level=3;
		else level=(level+1);
		pausetimer=5;
		waiting=true;
		flashticker=0;

	}
}
else if ((mode==0)&&(!waiting))
{
	if (key[KEY_SPACE])
	{
		mode=1;
		pausetimer=15;
		waiting=true;
		flashticker=0;
	}
}

// If esc is pressed, exit
if (key[KEY_ESC])
 endgame=1;
}


void move_blasts()
{
	register int i,j,k;
	
	for (i=1;i<46;i++)
		for (j=1;j<31;j++)
		{
			k=0;
			if(blast[i+1][j]==1)
			{
				newblast[i][j]=1;
				k++;
			}
			if(blast[i-1][j]==2)
			{
				newblast[i][j]=2;
				k++;
			}
			if(blast[i][j+1]==3)
			{
				newblast[i][j]=3;
				k++;
			}
			if(blast[i][j-1]==4)
			{
				newblast[i][j]=4;
				k++;
			}			
			if ((k!=1)|(mapsolid[level][i][j]==1))
				newblast[i][j]=0;
		}
		
	for (i=0;i<47;i++)
		for (j=0;j<32;j++)
			blast[i][j]=newblast[i][j];
}


void draw_title()
{
register int i,j;

pausetimer--;
if (pausetimer==0)
	waiting=false;


for (i=0;i<24;i++)
	for (j=0;j<32;j++)
	if (titlescreen[i][j]==0)
		rectfill(buffer, (j * 32) , (i * 32), ((j+1) * 32) , ((i+1) * 32) , makecol(0, 0, 0));
	else if (titlescreen[i][j]==1)
		rectfill(buffer, (j * 32) , (i * 32), ((j+1) * 32) , ((i+1) * 32) , makecol(100, 100, 100));
	else if (titlescreen[i][j]==2)
		rectfill(buffer, (j * 32) , (i * 32), ((j+1) * 32) , ((i+1) * 32) , makecol(255, 255, 0));

flashticker=(flashticker+1)%24;

if ((!waiting)&&((flashticker/12)==0))
for (i=0;i<5;i++)
	for (j=0;j<79;j++)
	{
		if (tostart[i][j]==1)
				rectfill(buffer, (j * 8)+192 , (i * 8)+640, ((j+1) * 8)+192 , ((i+1) * 8)+640, makecol(100, 100, 100));

	}
}

void draw_maps()
{
int i,j,k;


pausetimer--;
if (pausetimer==0)
	waiting=false;

flashticker=(flashticker+1)%18;


rectfill(buffer,0,0,1024,768,makecol(0,0,0));


		for (k=0; k<6; k++)
		for (i = 0; i < 47; i++)
		for (j = 0; j < 32; j++)
        {
			if (mapsolid[k][i][j]==1)
			{	if (k==level&&((flashticker/9)==0))
					rectfill(buffer, j*4 +320*(k%3)+104, i*4 + 240*(1+k/3)-16, (j+1)*4+320*(k%3)+104 , (i+1)*4 + 240*(1+k/3)-16, makecol(255, 255, 255));
				else
					rectfill(buffer, j*4 +320*(k%3)+104, i*4 + 240*(1+k/3)-16, (j+1)*4+320*(k%3)+104 , (i+1)*4 + 240*(1+k/3)-16, makecol(50, 50, 50));
			}	
		}

	for (i=0;i<5;i++)
		for (j=0;j<19;j++)
			if (leveltext[i][j]==1)
				rectfill(buffer, (j * 16)+360 , (i * 16)+64, ((j+1) * 16)+360 , ((i+1) * 16)+64, makecol(100, 100, 100));

}


//---------------------------------------------------------
// DRAW MAP FUNCTIONS
//---------------------------------------------------------

void draw_map(BITMAP *buffer, int x1, int y1)
{
  register int i, j;
  int l,h,t,th;
  

//health and power bars  
th=(57+curtime-d(p1x,p1y,p2x,p2y))%57;

//healths
rectfill(buffer, 32, 752, 32+p1healthhistory[curtime], 768, makecol(255,0,0));
rectfill(buffer, 512-32-p2healthhistory[th], 752, 512-32, 768, makecol(0,0,255));
//blaster charge
rectfill(buffer, 256-p1charge*2, 752, 256+p1charge*2, 768, makecol(255,255,0));

//healths
rectfill(buffer, 512+32, 752, 512+32+p1healthhistory[th], 768, makecol(255,0,0));
rectfill(buffer, 1024-32-p2healthhistory[curtime], 752, 1024-32, 768, makecol(0,0,255));
//blaster charge
rectfill(buffer, 512+256-p2charge*2, 752, 512+256+p2charge*2, 768, makecol(255,255,0));


if (p2healthhistory[th]==0)
{
	p1won=true;
	pausetimer--;
	if (pausetimer==0) 
		gameover=true;
}

if (p1healthhistory[th]==0)
{
	p2won=true;
	pausetimer--;
	if (pausetimer==0)
		gameover=true;
}

   // base level blitting for player 1
	if(p1dead)
		for (i = 0; i < 47; i++)
		{
		for (j = 0; j < 32; j++)
        {
			if (deadmap[i][j]==0)
				rectfill(buffer, (j * tilesize) , (i * tilesize) + y1, ((j+1) * tilesize) , ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else
				rectfill(buffer, (j * tilesize) , (i * tilesize) + y1, ((j+1) * tilesize) , ((i+1) * tilesize) + y1, makecol(50, 50, 50));
		}
		}
	else if (p2healthhistory[th]==0)
		for (i = 0; i < 47; i++)
		{
		for (j = 0; j < 32; j++)
        {
			if (winmap[i][j]==0)
				rectfill(buffer, (j * tilesize) , (i * tilesize) + y1, ((j+1) * tilesize) , ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else
				rectfill(buffer, (j * tilesize) , (i * tilesize) + y1, ((j+1) * tilesize) , ((i+1) * tilesize) + y1, makecol(255, 0, 0));
		}
		}
	else    for (i = 0; i < 47; i++)
    {
        for (j = 0; j < 32; j++)
        {
			t=(57+curtime-d(p1x,p1y,j,i))%57;
			if (history[t][i][j]==0)
				rectfill(buffer, (j * tilesize) + x1, (i * tilesize) + y1, ((j+1) * tilesize) + x1, ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else if (history[t][i][j]==1)
				rectfill(buffer, (j * tilesize) + x1, (i * tilesize) + y1, ((j+1) * tilesize) + x1, ((i+1) * tilesize) + y1, makecol(50, 50, 50));
			else if (history[t][i][j]==2)
				rectfill(buffer, (j * tilesize) + x1, (i * tilesize) + y1, ((j+1) * tilesize) + x1, ((i+1) * tilesize) + y1, makecol(255, 0, 0));
			else if (history[t][i][j]==3)
				rectfill(buffer, (j * tilesize) + x1, (i * tilesize) + y1, ((j+1) * tilesize) + x1, ((i+1) * tilesize) + y1, makecol(0, 0, 255));
			else if (history[t][i][j]==4)
				rectfill(buffer, (j * tilesize) + x1, (i * tilesize) + y1, ((j+1) * tilesize) + x1, ((i+1) * tilesize) + y1, makecol(255, 255, 0));

        }
    }

   // base level blitting for player 2
   if(p2dead)
   	for (i = 0; i < 47; i++)
    {
        for (j = 0; j < 32; j++)
        {
			if (deadmap[i][j]==0)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(50, 50, 50));
		}

	}
	else if (p1healthhistory[th]==0)
		for (i = 0; i < 47; i++)
		{
		for (j = 0; j < 32; j++)
        {
			if (winmap[i][j]==0)
				rectfill(buffer, (j * tilesize) +512, (i * tilesize) + y1, ((j+1) * tilesize) +512, ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else
				rectfill(buffer, (j * tilesize)+512 , (i * tilesize) + y1, ((j+1) * tilesize) +512, ((i+1) * tilesize) + y1, makecol(0, 0, 255));
		}
		}
	else for (i = 0; i < 47; i++)
    {
        for (j = 0; j < 32; j++)
        {
			t=(57+curtime-d(p2x,p2y,j,i))%57;

			if (history[t][i][j]==0)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(0, 0, 0));
			else if (history[t][i][j]==1)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(50, 50, 50));
			else if (history[t][i][j]==2)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(255, 0, 0));
			else if (history[t][i][j]==3)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(0, 0, 255));
			else if (history[t][i][j]==4)
				rectfill(buffer, (j * tilesize) + 512, (i * tilesize) + y1, ((j+1) * tilesize) + 512, ((i+1) * tilesize) + y1, makecol(255, 255, 0));

        }
    }
	
	
	flashticker=(flashticker+1)%24;

if (gameover&&(flashticker/12==0)) 
	for (i=0;i<5;i++)
	for (j=0;j<90;j++)
	{
		if (tocontinue[i][j]==1)
				rectfill(buffer, (j * 8)+152 , (i * 8)+460, ((j+1) * 8)+152 , ((i+1) * 8)+460, makecol(150, 150, 150));

	}
}

//---------------------------------------------------------
// INITIALIZE GRAPHICS
//---------------------------------------------------------

// initialise our graphics routnine
int initGraphics ()
{
 set_color_depth (32);
 if (set_gfx_mode(GFX_AUTODETECT,1024, 768, 0, 0))
 {
   // generate an error message
   // note: allegro_message can be used on any platform
   allegro_message ("Error: Could not initialize graphics mode!");
   return 0;
  
 }

 return 1;
}


void record_events()
{
register int i,j;
   for (i = 0; i < 47; i++)
    {
        for (j = 0; j < 32; j++)
        {
			 history[curtime][i][j] = mapsolid[level][i][j];
			 if (blast[i][j]!=0) 
				history[curtime][i][j]=4;
		}
	}
	history[curtime][p1y][p1x]=2;
	history[curtime][p2y][p2x]=3;
	p1healthhistory[curtime]=p1h;
	p2healthhistory[curtime]=p2h;
	//2=player 1
	//3=player 2
	
		

}

void health_check()
{
if (blast[p1y][p1x]>0)
{
	blast[p1y][p1x]=0;
	p1h=max(p1h-10,0);
}

if (blast[p2y][p2x]>0)
{
	blast[p2y][p2x]=0;
	p2h=max(p2h-10,0);
}

if (p1h==0) 
	p1dead=true;
if (p2h==0)
	p2dead=true;
}
//------------------------------------------------------------
//------------------------------------------------------------
// MAIN
//------------------------------------------------------------
//------------------------------------------------------------

int main (void)
{
// initialize allegro
allegro_init ();

// call initialization function
init();
 
 
 
        LOCK_FUNCTION(second_counter);
        LOCK_VARIABLE(fps);
        LOCK_VARIABLE(frames);
        LOCK_FUNCTION(ticker);
        LOCK_VARIABLE(ticks);
		
		        frames=timewaster_delay=0;

  install_int_ex(second_counter, BPS_TO_TIMER(1));
        install_int_ex(ticker, BPS_TO_TIMER(25));
		
 if (initGraphics())
 {
 // create our buffer
 buffer=create_bitmap (1024, 768);

 while (endgame==0)
{
curtime++;
curtime%=57;

// check for input
if (tick )
	input();
tick=!tick;

if (mode==0)
{
	draw_title();
}
else if (mode==1)
{
	draw_maps();
}
else if (mode==2)
{

health_check();

record_events();

// draw tile map
draw_map(buffer, 0, 0);

move_blasts();
}


  /* control timing */
                while (ticks<1)
                {
                        rest(0);
                }
                ticks=0;
                ++frames;

// Show the buffer & clear the buffer
showBuffer ();

// clear buffer
  clear(buffer);                               
}

}
// clean up allegro
 allegro_exit ();
 return 0;
}
END_OF_MAIN ();


